﻿Public Class Form1

    Dim FirstSymbol As Boolean = True
    Dim Prev_Value As Single
    Dim Symbol As String
    Dim Point As Boolean = False
    Dim Symbol_Clicked As Boolean = False, Num_Clicked As Boolean = False

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load



    End Sub



    '■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
    '■■
    '■■　表示のクリア
    '■■
    '■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
    Private Sub Btn_C_Click(sender As Object, e As EventArgs) Handles Btn_C.Click

        'ディスプレイの表示をクリア
        Me.Val_Display.Text = "0"

        '直前に入力された数字をクリア
        Prev_Value = 0

        '演算記号の初回入力判定フラグをクリア
        FirstSymbol = False

        '演算記号保持変数を初期化
        Symbol = ""

        '演算記号が入力されたフラグをクリア
        Symbol_Clicked = True

        '数字が入力されたフラグをクリア
        Num_Clicked = False

    End Sub




    '■「0」キークリック
    Private Sub Num_0_Click(sender As Object, e As EventArgs) Handles Num_0.Click

        'Me.Val_Display.Text = CStr(Val(Me.Val_Display.Text & "0"))
        Call Numeric_Display(0)

    End Sub


    '■「1」キークリック
    Private Sub Num_1_Click(sender As Object, e As EventArgs) Handles Num_1.Click

        Call Numeric_Display(1)

    End Sub


    '■「2」キークリック
    Private Sub Num_2_Click(sender As Object, e As EventArgs) Handles Num_2.Click

        Call Numeric_Display(2)

    End Sub


    '■「3」キークリック
    Private Sub Num_3_Click(sender As Object, e As EventArgs) Handles Num_3.Click

        Call Numeric_Display(3)

    End Sub


    '■「4」キークリック
    Private Sub Num_4_Click(sender As Object, e As EventArgs) Handles Num_4.Click

        Call Numeric_Display(4)

    End Sub


    '■「5」キークリック
    Private Sub Num_5_Click(sender As Object, e As EventArgs) Handles Num_5.Click

        Call Numeric_Display(5)

    End Sub


    '■「6」キークリック
    Private Sub Num_6_Click(sender As Object, e As EventArgs) Handles Num_6.Click

        Call Numeric_Display(6)

    End Sub


    '■「7」キークリック
    Private Sub Num_7_Click(sender As Object, e As EventArgs) Handles Num_7.Click

        Call Numeric_Display(7)

    End Sub


    '■「8」キークリック
    Private Sub Num_8_Click(sender As Object, e As EventArgs) Handles Num_8.Click

        Call Numeric_Display(8)

    End Sub


    '■「9」キークリック
    Private Sub Num_9_Click(sender As Object, e As EventArgs) Handles Num_9.Click

        Call Numeric_Display(9)

    End Sub


    '■小数点「.」キークリック
    Private Sub Btn_Point_Click(sender As Object, e As EventArgs) Handles Btn_Point.Click

        '現在の表示値において小数点が未入力であれば、小数点の入力を許可する
        If Point = False Then
            Me.Val_Display.Text = Me.Val_Display.Text & "." '小数点の追加
            Point = True '小数点入力済みフラグを立てる

            '同時に、数字が入力されたフラグも立てる
            Num_Clicked = True

        End If

    End Sub





    '■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
    '■■
    '■■　数字入力時の処理
    '■■
    '■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
    Sub Numeric_Display(Num As Integer)

        '直前の入力が演算記号だったら、ディスプレイの表示はそのまま今回の入力値で更新する
        If Symbol_Clicked = True Then

            If Prev_Value = 0 And Symbol = "-" Then '直前の入力がマイナス(－)であれば値に反映
                Me.Val_Display.Text = "-" & CStr(Num) 'CStr() 関数で数字を文字へ変換

                '初回のキー入力がマイナス記号だった場合は演算記号ではなく符号と捉え、Symbol関連変数を初期化する
                Symbol = ""
                FirstSymbol = True
            Else
                Me.Val_Display.Text = CStr(Num) 'CStr() 関数で数字を文字へ変換
            End If

            Symbol_Clicked = False '直前の演算記号入力フラグをクリア
            Point = False '小数点入力済みフラグをクリア
        Else
            If Me.Val_Display.Text = "0" And Num = 0 Then
                Me.Val_Display.Text = "0"
            End If

            Me.Val_Display.Text = CStr(CDec(Me.Val_Display.Text & CStr(Num)))

        End If

        '数字が入力されたフラグを立てる
        Num_Clicked = True

    End Sub






    '■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
    '■■
    '■■　演算記号「＋、－、×、÷」入力時の処理
    '■■
    '■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
    Sub Calc(Current_Symbol As String)

        If Num_Clicked = True Then '直前の入力値が演算記号ではなく数字である場合

            '演算記号の入力が 2回目以降であれば以下の処理を実行
            If FirstSymbol = False Then

                '前回の入力値と今回の入力値を計算し、結果をディスプレイへ表示
                Select Case Symbol
                    Case "+"
                        Me.Val_Display.Text = CDec(Prev_Value + CDec(Me.Val_Display.Text))
                    Case "-"
                        Me.Val_Display.Text = CDec(Prev_Value - CDec(Me.Val_Display.Text))
                    Case "*"
                        Me.Val_Display.Text = CDec(Prev_Value * CDec(Me.Val_Display.Text))
                    Case "/"
                        Me.Val_Display.Text = CDec(Prev_Value / CDec(Me.Val_Display.Text))
                End Select

                Prev_Value = Val(Me.Val_Display.Text) '計算された現在の表示値を変数へ格納
            End If

            '演算記号の初回入力かどうかを判断し、初回であれば初回フラグを下げる
            If FirstSymbol = True Then
                FirstSymbol = False
                Prev_Value = Val(Me.Val_Display.Text) '現在の表示値を変数へ格納
            End If


        End If


        '今回入力された演算記号を変数へ保持
        Symbol = Current_Symbol

        '演算記号が入力されたフラグを立てる
        Symbol_Clicked = True

        '数字が入力されたフラグをクリア
        Num_Clicked = False



    End Sub



    '■「+」キークリック
    Private Sub Btn_Plus_Click(sender As Object, e As EventArgs) Handles Btn_Plus.Click

        '演算記号「+」を計算用ルーチンへ渡して実行
        Call Calc("+")

    End Sub


    '■「-」キークリック
    Private Sub Btn_minus_Click(sender As Object, e As EventArgs) Handles Btn_minus.Click

        '演算記号「-」を計算用ルーチンへ渡して実行
        Call Calc("-")

    End Sub

    '■「×」キークリック
    Private Sub Btn_Multiplied_by_Click(sender As Object, e As EventArgs) Handles Btn_Multiplied_by.Click

        '演算記号「*」を計算用ルーチンへ渡して実行
        Call Calc("*")

    End Sub


    '■「÷」キークリック
    Private Sub Btn_Divided_by_Click(sender As Object, e As EventArgs) Handles Btn_Divided_by.Click

        '演算記号「/」を計算用ルーチンへ渡して実行
        Call Calc("/")

    End Sub



    '■「=」キークリック
    Private Sub Btn_Equal_Click(sender As Object, e As EventArgs) Handles Btn_Equal.Click

        Call Calc("=")

    End Sub




End Class
